﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace erettsegi05_Zenei_adok
{
    struct TSzám
    {
        public int index; //technikai mező 
        public byte adó;
        public TimeSpan idő;
        public string előadó;
        public string szám;
    }

    class erettsegi05_Zenei_adok
    {
        static void Main()
        {
            #region 1. feladat: Adatok beolvasása
            Console.WriteLine("1. Feladat: Adatok beolvasása");

            List <TSzám> Számok = new List <TSzám> ();
            using (StreamReader sr = new StreamReader(@"musor.txt"))
            {
                int db=int.Parse(sr.ReadLine());
                for (int i = 0; i < db; i++)
                {
                    string s = sr.ReadLine();
                    string[] fields = s.Split(' '); // adatok feldarabolása
                    TSzám új_szám;
                    új_szám.index = i;
                    új_szám.adó = byte.Parse(fields[0]);
                    új_szám.idő = TimeSpan.Parse("0:"+fields[1] + ':' + fields[2]);
                    string s2 = fields[3];
                    for (int j = 4; j < fields.Count(); j++) s2 += ' '+ fields[j];
                    string[] fields2 = s2.Split(':'); // előadó és szám elválasztása
                    új_szám.előadó = fields2[0];
                    új_szám.szám = fields2[1];
                    Számok.Add(új_szám);
                }
            }
            #endregion

            #region 2. feladat: Számok daradszáma adókként

            Console.WriteLine("2. Számok darabszáma adókként:");
            var szdb = from i in Számok
                       group i by i.adó into g
                       select new{Adó=g.Key, Darab=g.Count()};

            foreach (var i in szdb) Console.WriteLine("{0}. adón:{1} db", i.Adó, i.Darab);
            #endregion

            #region 3. feladat: Eltelt idő az Eric Clapton számok között
            Console.WriteLine("1. Eltelt idő az Eric Clapton számok között:");
            var Slowhand = from i in Számok
                           where i.adó==1 && i.előadó=="Eric Clapton"
                           orderby i.index
                           select i;

            TimeSpan eltelt_idő = new TimeSpan();
           
            for (int i = Slowhand.First().index ; i <= Slowhand.Last().index; i++) 
                if (Számok[i].adó==1) eltelt_idő+=Számok[i].idő;

            Console.WriteLine("Óra:{0} Perc: {1} Másodperc: {2}",
                eltelt_idő.Hours, eltelt_idő.Minutes, eltelt_idő.Seconds);
            #endregion

            #region 4. feladat: Eszter és az Omega
            Console.WriteLine("4. Eszter és az Omega:");

            //Linq-val:
            int Omega_start = (from i in Számok
                              where i.előadó == "Omega" && i.szám == "Legenda"
                              select i.index).First();

            //delegáltal:
            //int Omega_start = Számok.FindIndex(delegate(TSzám t1) 
            //{ return t1.előadó == "Omega" && t1.szám == "Legenda"; });

            string[] utolsó_szám=new string[3];
            for (int i = 0; i < Omega_start; i++)
                utolsó_szám[Számok[i].adó - 1] = 
                    Számok[i].előadó + ':' + Számok[i].szám;

            Console.WriteLine("Az Omega Legenda c. dala a(z) {0}. adón szólt!",
                Számok[Omega_start].adó);
            for (int i = 0; i < utolsó_szám.Count(); i++)
            {
                if (i != Számok[Omega_start].adó - 1)
                    Console.WriteLine("Közben a(z) {0}. adón a köv. szám volt hallható:{1}",
                        i + 1, utolsó_szám[i]);
            }
            #endregion

            #region 5. feladat: SMS keresés
            Console.WriteLine("5. SMS keresés");
            Console.WriteLine("Kérem a keresendő karaktereket:");
            string k = Console.ReadLine();

            using (StreamWriter sw = new StreamWriter("keres.txt"))
            {
                sw.WriteLine(k);
                foreach (TSzám akt_szám in Számok)
                {
                    string s = akt_szám.előadó +':'+akt_szám.szám;
                    int talált_db = 0;
                    for (int i = 0; i < s.Length && talált_db<k.Length; i++) 
                        if (char.ToUpper(k[talált_db]) == 
                            char.ToUpper(s[i])) talált_db++;
                    if (talált_db == k.Length) sw.WriteLine(s);
                }
            }
            #endregion

            #region 6. feladat: Új műsorrend az 1. adón
            Console.WriteLine("6. Új műsorrend az 1. adón");

            TimeSpan bevezető = new TimeSpan(0, 1, 0);
            TimeSpan aktidő = new TimeSpan(0, 3, 0); //mivel 3 perces hírekkel indul a műsor
            TimeSpan összidő = new TimeSpan();

            foreach (TSzám i in Számok)
            {
                if (i.adó == 1)
                {
                    if (aktidő + bevezető + i.idő < TimeSpan.Parse("1:0:0"))
                    {
                       aktidő += bevezető + i.idő;
                    } else 
                    {
                        összidő+=TimeSpan.Parse("1:0:0");
                        aktidő = TimeSpan.Parse("0:3:0")+bevezető+i.idő;
                    }
                }
            }
            összidő += aktidő; //utolsó óra számainak hozzáadása
            Console.WriteLine("Az 1. adó befejezi az adást: {0}:{1}:{2}",
                összidő.Hours, összidő.Minutes, összidő.Seconds);
            #endregion

            Console.ReadKey();
        }
    }
}